# wxLogChain Class Reference
[Logging]

`#include <wx/log.h>`

Inheritance diagram for wxLogChain:
[legend]

## Detailed Description

This simple class allows you to chain log sinks, that is to install a new sink but keep passing log messages to the old one instead of replacing it completely as wxLog::SetActiveTarget does.

It is especially useful when you want to divert the logs somewhere (for example to a file or a log window) but also keep showing the error messages using the standard dialogs as wxLogGui does by default.

Example of usage:

        wxLogChain *logChain = new wxLogChain(new wxLogStderr);

        // all the log messages are sent to stderr and also processed as usually
        ...

        // don't delete logChain directly as this would leave a dangling
        // pointer as active log target, use SetActiveTarget() instead
        delete wxLog::SetActiveTarget(...something else or NULL...);

##

Library: wxBase

Category: Logging

## Public Member Functions
| wxLogChain (wxLog *logger)
| Sets the specified `logger` (which may be NULL) as the default log target but the log messages are also passed to the previous log target if any.
virtual | ~wxLogChain ()
| Destroys the previous log target.
void | DetachOldLog ()
| Detaches the old log target so it won't be destroyed when the wxLogChain object is destroyed.
wxLog * | GetOldLog () const
| Returns the pointer to the previously active log target (which may be NULL).
bool | IsPassingMessages () const
| Returns true if the messages are passed to the previously active log target (default) or false if PassMessages() had been called.
void | PassMessages (bool passMessages)
| By default, the log messages are passed to the previously active log target.
void | SetLog (wxLog *logger)
| Sets another log target to use (may be NULL).

List of all members.

## Constructor & Destructor Documentation

wxLogChain::wxLogChain | ( | wxLog * | logger | ) |

Sets the specified `logger` (which may be NULL) as the default log target but the log messages are also passed to the previous log target if any.

virtual wxLogChain::~wxLogChain | ( |  | ) | `[virtual]`

Destroys the previous log target.

## Member Function Documentation

void wxLogChain::DetachOldLog | ( |  | ) |

Detaches the old log target so it won't be destroyed when the wxLogChain object is destroyed.

wxLog* wxLogChain::GetOldLog | ( |  | ) | const

Returns the pointer to the previously active log target (which may be NULL).

bool wxLogChain::IsPassingMessages | ( |  | ) | const

Returns true if the messages are passed to the previously active log target (default) or false if PassMessages() had been called.

void wxLogChain::PassMessages | ( | bool | passMessages | ) |

By default, the log messages are passed to the previously active log target.

Calling this function with false parameter disables this behaviour (presumably temporarily, as you shouldn't use wxLogChain at all otherwise) and it can be reenabled by calling it again with passMessages set to true.

void wxLogChain::SetLog | ( | wxLog * | logger | ) |

Sets another log target to use (may be NULL).

The log target specified in the wxLogChain(wxLog*) constructor or in a previous call to this function is deleted. This doesn't change the old log target value (the one the messages are forwarded to) which still remains the same as was active when wxLogChain object was created.

|  | [ top ]